var EXPORTED_SYMBOLS = ["cyclone3xuladmin", "log", "Cyclone3", "Cyclone3N", "Cyclone3Uploads", "Cyclone3DragDrop"];
//"dragdropobject"

const reduce = Function.bind.call(Function.call, Array.prototype.reduce);
const isEnumerable = Function.bind.call(Function.call, Object.prototype.propertyIsEnumerable);
const concat = Function.bind.call(Function.call, Array.prototype.concat);

var cyclone3xuladmin = {
	
	/* A more verbose way: creates .keyValue and .keyAttributes for every single xml tag */
	JXON: 
	{
		parseText: function(sValue) {
			return sValue.toString();
		},
		
		getJXONTree: function(oXMLParent)
		{
			
			if (typeof oXMLParent == "string")
			{
				var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
					.createInstance(Components.interfaces.nsIDOMParser);
				oXMLParent = parser.parseFromString(oXMLParent, "application/xml");
			}
			
			var vResult = /* put here the default value for empty nodes! */ '',
				nLength = 0,
				sCollectedTxt = "";
			
//			if (oXMLParent.nodeName=='#document') {
//				if (oXMLParent.firstChild.nodeName=='body') {
//					oXMLParent = oXMLParent.firstChild.firstChild;
//				}else if (oXMLParent.firstChild.nodeName=='header') {
//					oXMLParent = oXMLParent.firstChild;
//				}
//			}
		  
			if (oXMLParent.attributes && oXMLParent.attributes.length)
			{
				vResult = {};
				for (nLength; nLength < oXMLParent.attributes.length; nLength++)
				{
					oAttrib = oXMLParent.attributes.item(nLength);
					vResult["@" + oAttrib.name] = cyclone3xuladmin.JXON.parseText(oAttrib.value.trim());
				}
			}
			
//			if (oXMLParent.hasAttributes())
//			{
//				vResult = {};
//				for (nLength; nLength < oXMLParent.attributes.length; nLength++) 
//				{
//					oAttrib = oXMLParent.attributes.item(nLength);
//					vResult["@" + oAttrib.name] = cyclone3xuladmin.JXON.parseText(oAttrib.value.trim());
//				}
//			}
			
			if (oXMLParent.hasChildNodes()) 
			{
//				log('haschildnodes()')
				for (var oNode, sProp, vContent, nItem = 0; nItem < oXMLParent.childNodes.length; nItem++) 
				{
					oNode = oXMLParent.childNodes.item(nItem);
//					log(' node type=' + oNode.nodeType);
					if (oNode.nodeType === 4) { sCollectedTxt += oNode.nodeValue; }
					else if (oNode.nodeType === 3) { sCollectedTxt += oNode.nodeValue.trim(); }
					else if (oNode.nodeType === 2) {
//						log(' attribute node')
					}
					else if (oNode.nodeType === 1 && !oNode.prefix) 
					{
//						log("node=" + JSON.stringify(oNode));
						if (nLength === 0) { vResult = {}; }
						//sProp = oNode.nodeName.toLowerCase();
						sProp = oNode.nodeName;
						vContent = cyclone3xuladmin.JXON.getJXONTree(oNode);
						if (vResult.hasOwnProperty(sProp)) 
						{
							if (vContent['@_array'])
							{
								delete vContent['@_array'];
							}
							if (vResult[sProp].constructor !== Array)
							{
								vResult[sProp] = [vResult[sProp]];
							}
							vResult[sProp].push(vContent);
						}
						else if (vContent['@_array'])
						{
							delete vContent['@_array'];
							vResult[sProp] = [vContent]; nLength++;
						}
//						else if (oXMLParent.parentNode)
//						{
//							vResult[sProp] = [vContent]; nLength++;
//						}
						else
						{
							vResult[sProp] = vContent; nLength++;
//							vResult[sProp] = [vContent]; nLength++;
						}
					}
				}
			}
			if (sCollectedTxt) { nLength > 0 ? vResult.value = cyclone3xuladmin.JXON.parseText(sCollectedTxt) : vResult = cyclone3xuladmin.JXON.parseText(sCollectedTxt); }
			
			return vResult;
		},
		createXML: function (oObjTree) 
		{
			function loadObjTree (oParentEl, oParentObj) 
			{
				var vValue, oChild;
				if (oParentObj instanceof String || oParentObj instanceof Number || oParentObj instanceof Boolean) 
				{
					oParentEl.appendChild(oNewDoc.createTextNode(oParentObj.toString()));
				} else if (oParentObj.constructor === Date) 
				{
					oParentEl.appendChild(oNewDoc.createTextNode(oParentObj.toGMTString()));    
				}
	
				for (var sName in oParentObj) 
				{
					if (isFinite(sName)) { continue; } /* verbosity level is 0 */
					vValue = oParentObj[sName];
					if (sName === "keyValue") 
					{
						if (vValue !== null && vValue !== true) 
						{
							oParentEl.appendChild(oNewDoc.createTextNode(vValue.constructor === Date ? vValue.toGMTString() : String(vValue))); 
						}
					} else if (sName === "keyAttributes")
					{ 
						for (var sAttrib in vValue) 
						{
							oParentEl.setAttribute(sAttrib, vValue[sAttrib]); 
						}
					} else if (sName.charAt(0) === "@") 
					{
						oParentEl.setAttribute(sName.slice(1), vValue);
					} else if (vValue.constructor === Array) 
					{
						for (var nItem = 0; nItem < vValue.length; nItem++) 
						{
							oChild = oNewDoc.createElement(sName);
							loadObjTree(oChild, vValue[nItem]);
							oParentEl.appendChild(oChild);
						}
					} else 
					{
						oChild = oNewDoc.createElement(sName);
						if (vValue instanceof Object) 
						{
							loadObjTree(oChild, vValue);
						} else if (vValue !== null && vValue !== true) 
						{
							oChild.appendChild(oNewDoc.createTextNode(vValue.toString()));
						}
						oParentEl.appendChild(oChild);
					}
				}
			}
			const oNewDoc = document.implementation.createDocument("", "", null);
			loadObjTree(oNewDoc, oObjTree);
			
			return oNewDoc;
		},
		
		convert_XML_JXON: function (xml_object)
		{
			var result_json = cyclone3xuladmin.JXON.getJXONTree(xml_object);
			return result_json;
		},
		
		convert_JXON_XML: function (json_object)
		{
			var result_xml = cyclone3xuladmin.JXON.createXML(json_object);
			
			return result_xml;
		}
		
	},
	
	getElementsWithAttribute: function(elRoot, elAttribute, objectPoll, processDepth)
	{
		// uncomment line below for debugging via console.log
		// Components.utils.import('resource://gre/modules/devtools/Console.jsm');
		if(!objectPoll)
		{
			objectPoll=new Array()
		}
		if (!processDepth)
		{
			processDepth=0;
		}
		processDepth++
		if (elRoot)
		{
			var nodelist=elRoot.childNodes;
			if (!nodelist.length)
			{
				try
				{
					Components.utils.import("resource://gre/modules/Services.jsm");
					var doc = Services.appShell.hiddenDOMWindow.document;
					nodelist=doc.getAnonymousNodes(elRoot);
				}catch(e)
				{
					log('[master.jsm:cyclone3xuladmin] {getElementsWithAttribute} '+e);
					return new Array();
				}
			}
			if(nodelist.length)
			{
				for(var i=0;i<nodelist.length;i++)
				{
					var currentChild=nodelist[i];
					if (currentChild.nodeType != 1) {
						// not an element node type, skip it
						continue;
					}
					try 
					{
						if(currentChild.getAttribute(elAttribute.name) == elAttribute.value)
						{
							objectPoll.push(currentChild)
						}
					}catch(e){
						log('[master.jsm:cyclone3xuladmin] {getElementsWithAttribute} debug1 '+e);
					}
					
					if(currentChild.childNodes.length)
					{
						try {
							var tmpReturn=this.getElementsWithAttribute(currentChild, elAttribute, objectPoll, processDepth)
							objectPoll=tmpReturn
						} catch(e) {
							log('[master.jsm:cyclone3xuladmin] {getElementsWithAttribute} debug2 '+e)
						}
					}
					else
					{
						continue
					}
				}
			}
		}
		return objectPoll
	},
	
	core: {
		
		log :
		{
			
			loglevel: 10,
			
			append : function (logText, log_level)
			{
				if (log_level)
				{
					if (log_level > this.loglevel) return;
				
				} else if (this.loglevel == 0) return;
							
				var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
					getService(Components.interfaces.nsIConsoleService);
				aConsoleService.logStringMessage(logText);
			},
			
			getPreferredLogLevel : function ()
			{	
				var prefs = Components
					.classes["@mozilla.org/preferences-service;1"] 
					.getService(Components.interfaces.nsIPrefService)
					.getBranch(const_Cyclone3XULAdminPrefsRoot);
				try 
				{
					var loglevel = prefs.getIntPref('logLevel');
				}catch(e)
				{
					prefs.setIntPref('logLevel',0);
					var loglevel = prefs.getIntPref('logLevel');
				}
				return loglevel;
			}
		},
		bugfix: {
			// XXX Firefox 51 has a regression that calls setCellText immediately
			// upon calling startEditing. Hacks below to see if startEditing is in the
			// call stack.
			setCellText: function(col, val)
			{
				if (col && !val)
				{
					try {
						throw Error('[master.jsm:cyclone3xuladmin] {bugfix} FF51 setCellText regression');
					} catch(ex) {
						if (ex.stack && ex.stack.indexOf('startEditing') != -1)
						{
							return false;
						}
					}
				}
				return true;
			},
			objectValues: function(obj)
			{
				var vals = [];
				for (var k in obj)
				{
					vals.push(obj[k]);
				}
				return vals;
				/*return reduce(
					keys,
					(v, k) => concat(
						v,
						typeof k === 'string' && isEnumerable(O, k) ? [O[k]] : []
					),
					[]
				);*/
			}
		}
	},
	
	gen_SOAPBroadcaster:
	{
		//broadcaster identificator string
		var_id: "window_broadcast",
		
		//SOAP listener pool
		obj_listenerPool: {},
		
		//unique listener ordinal
		var_listenerOrdinal: 0,
		
		//count of registered SOAP listeners
		var_listenerCount: 0,
		
		//broadcasts the response
		fnc_broadcast: function(rHeader, rBody)
		{
//			log('[master.jsm:cyclone3xuladmin] {fnc_broadcast} var_listenerCount: '+this.var_listenerCount);
			if(this.var_listenerCount>0)
			{
				//alert('broadcasting! listeners: '+this.var_listenerCount);
//				log('[master.jsm:cyclone3xuladmin] {fnc_broadcast} broadcasting!');
				
				for (var listener of Object.values(this.obj_listenerPool))
				{
					//alert(listener);
					listener.fnc_onBroadcast(rHeader, rBody);
				}
			}
		},
		
		fnc_listenerRegister: function(listeningObject)
		{
			var tmpOrdinal = ++this.var_listenerOrdinal;
			this.obj_listenerPool['listener'+tmpOrdinal] = listeningObject;
			this.var_listenerCount++;
			log('[master.jsm:cyclone3xuladmin] {fnc_listenerRegister} ['+this.var_id+'] listener #' + tmpOrdinal + ' ' + listeningObject.obj_SOAP.var_id + ' added to pool (' + this.var_listenerCount + ' active)');
			
			return {ordinal: tmpOrdinal};
		},
		
		fnc_listenerUnregister: function(listenerOrdinal)
		{
			delete this.obj_listenerPool['listener'+listenerOrdinal];
			this.var_listenerCount--;
			log('[master.jsm:cyclone3xuladmin] {fnc_listenerUnregister} ['+this.var_id+'] listener #' + listenerOrdinal + ' removed from pool (' + this.var_listenerCount + ' active)');
			
			return true;
		}
	},
	
	aProperties: function(newatom) {
		this.atom = newatom || '';
		this.AppendElement = function(atom) {
			this.atom = this.atom + ' ' + atom;
		}
	}
	
};

var log = function(message, level)
{
	cyclone3xuladmin.core.log.append(message, level)
};

/* here domain service lives */
var Cyclone3={};

/* Global object */

if (typeof Cyclone3N == "undefined") {
	var Cyclone3N = {
		init : function() {
			Components.classes["@mozilla.org/observer-service;1"].
				getService(Components.interfaces.nsIObserverService);
		}
	};
	Cyclone3N.init();
};

/*
if (typeof dragdropobject == "undefined") {
	var dragdropobject = {
		init : function() {
			Components.classes["@mozilla.org/observer-service;1"].
				getService(Components.interfaces.nsIObserverService);
		}
	};
	dragdropobject.init();
};
*/


/* Global storage for uploads */

var Cyclone3Uploads = {
	'maxSimultaneous': 5,
	'windowClosed': false,
	'running': 0,
	'count'	: 0,
	'count_global'	: 0,
	'counter': 0,
	'pool'	: {
		'uploads': {},
		'labels': []
	}
};

/* Global drag'n'drop object */

var Cyclone3DragDrop = {
	'ddobject': {},
	'files': [],
	'services': {
		'onDrop': function(event,url)
		{
			var canvas = document.createElementNS("http://www.w3.org/1999/xhtml","html:canvas");
			var ctx = canvas.getContext("2d");
			
			img = new Image();
			img.src = url;
			canvas.width = img.width;
			canvas.height = img.height;
			ctx.drawImage(img,0,0,img.width,img.height);
			
			var dt = event.dataTransfer;
			dt.setDragImage(canvas, 5, 5);
		}
	},
	'boardObserver':
	{
		'getSupportedFlavours' : function ()
		{
			var flavours = new FlavourSet();
			flavours.appendFlavour("text/unicode");
			flavours.appendFlavour("text/x-moz-url");
			flavours.appendFlavour("application/x-moz-file");
			return flavours;
		},
		'onDragOver': function (evt,flavour,session)
		{
			//log('dragover');
		},
		'onDrop': function (evt,dropdata,session)
		{
			
			log('[master.jsm:Cyclone3DragDrop] onDrop ContentType=' + dropdata.flavour.contentType + ' data='+dropdata.data)
			/*
			dragdropobject.type=dropdata.flavour.contentType
			dragdropobject.ID=dropdata.data
			dragdropobject.IDArray = dropdata.data.split("\n");
			*/
		}
	},
	'listObserver':
	{
		onDragStart: function (evt,transferData,action)
		{
			var txt='text';
			transferData.data=new TransferData();
			transferData.data.addDataForFlavour("text/unicode",txt);
		}
	}
};

if (!Object.values)
{
	Object.values = cyclone3xuladmin.core.bugfix.objectValues;
}

// *********************************************
//  Drag and Drop
// *********************************************
/*
var listObserver =
{
	onDragStart: function (evt,transferData,action)
	{
		var txt='text';
		transferData.data=new TransferData();
		transferData.data.addDataForFlavour("text/unicode",txt);
	}
};

var boardObserver =
{
	getSupportedFlavours : function ()
	{
		var flavours = new FlavourSet();
		flavours.appendFlavour("text/unicode");
		flavours.appendFlavour("text/x-moz-url");
		flavours.appendFlavour("application/x-moz-file");
		return flavours;
	},
	onDragOver: function (evt,flavour,session)
	{
		//log('dragover');
	},
	onDrop: function (evt,dropdata,session)
	{
		
		log('onDrop ContentType=' + dropdata.flavour.contentType + ' data='+dropdata.data)
	}
};

var dragdropServices =
{
	onDrop: function(event,url)
	{
		var canvas = document.createElementNS("http://www.w3.org/1999/xhtml","html:canvas");
		var ctx = canvas.getContext("2d");
		
		img = new Image();
		img.src = url;
		canvas.width = img.width;
		canvas.height = img.height;
		ctx.drawImage(img,0,0,img.width,img.height);
		
		var dt = event.dataTransfer;
		dt.setDragImage(canvas, 5, 5);
	}
}*/