<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
	version="1.0"
	xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0"
	xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0"
	xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0"
	xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"
	xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"
	xmlns:xlink="http://www.w3.org/1999/xlink"
	xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0" 
	xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"
	xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"
	xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0"
	xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0"
	xmlns:math="http://www.w3.org/1998/Math/MathML"
	xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0"
	xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0"
	xmlns:dom="http://www.w3.org/2001/xml-events"
	xmlns:xforms="http://www.w3.org/2002/xforms"
	xmlns:xsd="http://www.w3.org/2001/XMLSchema"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:presentation="urn:oasis:names:tc:opendocument:xmlns:presentation:1.0"
	office:class="text"
	office:version="1.0">
<!--

This stylesheet expects:

<row>
	<name>value</name>
	<street>value</street>
	<city>value</city>
	<country>value</country>
</row>

-->

<xsl:output	
		method="xml" indent="yes" encoding="utf-8" 
	/>

	
<xsl:template match="/">

<xsl:variable name="maxcells" select="count(/*/row)"/>
<xsl:variable name="columns" select="2"/>


<office:document-content xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0" xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0" xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0" xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0" xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0" xmlns:presentation="urn:oasis:names:tc:opendocument:xmlns:presentation:1.0" xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0" xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0" xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0" xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0" xmlns:ooo="http://openoffice.org/2004/office" xmlns:ooow="http://openoffice.org/2004/writer" xmlns:oooc="http://openoffice.org/2004/calc" xmlns:dom="http://www.w3.org/2001/xml-events" xmlns:xforms="http://www.w3.org/2002/xforms" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" office:version="1.0"><office:scripts/><office:font-face-decls><style:font-face style:name="Arial" svg:font-family="Arial" style:font-family-generic="swiss" style:font-pitch="variable"/>

<style:font-face style:name="Tahoma" svg:font-family="Tahoma" style:font-family-generic="system" style:font-pitch="variable"/>
</office:font-face-decls>

<office:automatic-styles>

<style:style style:name="co1" style:family="table-column">
	<style:table-column-properties fo:break-before="auto" style:column-width="9cm"/>
</style:style>

<style:style style:name="ce1" style:family="table-cell" style:parent-style-name="Default">
	<style:table-cell-properties style:vertical-align="middle"/>
</style:style>

<style:style style:name="ro1" style:family="table-row">
	<style:table-row-properties style:row-height="3cm" fo:break-before="auto" />
</style:style>

<style:style style:name="ta1" style:family="table" style:master-page-name="Default">
	<style:table-properties table:display="true" style:writing-mode="lr-tb"/>
	
</style:style>

</office:automatic-styles>

<office:body>
<office:spreadsheet>


<table:table table:name="Sheet1" table:style-name="ta1" table:print="false"><office:forms form:automatic-focus="false" form:apply-design-mode="false"/>

<table:table-column table:style-name="co1" table:default-cell-style-name="co1"/>
<table:table-column table:style-name="co1" table:default-cell-style-name="co1"/>


	<xsl:call-template name="drawrow">
		<xsl:with-param name="maxcells" select="$maxcells" />
		<xsl:with-param name="currentcount" select="1" />
		<xsl:with-param name="columns" select="$columns" />
	</xsl:call-template>

 </table:table>



</office:spreadsheet></office:body></office:document-content>
	
</xsl:template>

<xsl:template name="drawrow">
	<xsl:param name="maxcells" />
	<xsl:param name="currentcount" />
	<xsl:param name="columns" />

	
		<xsl:if test="($currentcount - 1) mod $columns = 0">

			<table:table-row table:style-name="ro1">
			<xsl:call-template name="drawcell">
      				<xsl:with-param name="currentcount" select="$currentcount" />
				<xsl:with-param name="subcount" select="$columns" />
    			</xsl:call-template>
			</table:table-row>
	
		</xsl:if>
	
	<xsl:if test="$currentcount &lt; $maxcells">

			<xsl:call-template name="drawrow">
      				<xsl:with-param name="maxcells" select="$maxcells" />
				<xsl:with-param name="currentcount" select="$currentcount + 1" />
      				<xsl:with-param name="columns" select="$columns" />
    			</xsl:call-template>

	</xsl:if>

</xsl:template>

<xsl:template name="drawcell">
	<xsl:param name="currentcount" />
	<xsl:param name="subcount" />
	
	<table:table-cell office:value-type="string" table:style-name="ce1">
			
		<xsl:variable name="adrpostal">
        		<xsl:copy-of select="/*/row[$currentcount]/address_postal"/>
   		</xsl:variable>

		<text:p>
		<xsl:choose>
			<xsl:when test="(/*/row[$currentcount]/fullname)">
				<xsl:value-of select="/*/row[$currentcount]/fullname" />
			</xsl:when>

			<xsl:otherwise>
				<xsl:value-of select="/*/row[$currentcount]/name" />
			</xsl:otherwise>
		</xsl:choose>
		</text:p>
		
		<xsl:choose>

			<xsl:when test="string($adrpostal)">
				
				<text:p><xsl:value-of select="$adrpostal" /></text:p>
		
			</xsl:when>

			<xsl:otherwise>
				<text:p><xsl:value-of select="/*/row[$currentcount]/street" /></text:p>
				<text:p><xsl:value-of select="/*/row[$currentcount]/city" /></text:p>
				<text:p><xsl:value-of select="/*/row[$currentcount]/country" /></text:p>
			</xsl:otherwise>
		
		</xsl:choose>	

	</table:table-cell>

	<xsl:if test="$subcount &gt; 1">

			<xsl:call-template name="drawcell">
				<xsl:with-param name="currentcount" select="$currentcount + 1" />
      				<xsl:with-param name="subcount" select="$subcount - 1" />
    			</xsl:call-template>

	</xsl:if>

</xsl:template>

</xsl:stylesheet>
